require "rubocop/rake_task"

module AdvertileCop
  class RakeTask < RuboCop::RakeTask
    def initialize(name, *args, &task_block)
      setup_ivars(args)

      desc "Run RuboCop" unless ::Rake.application.last_description

      task(name, *args) do |_, task_args|
        RakeFileUtils.send(:verbose, verbose) do
          yield(*[self, task_args].slice(0, task_block.arity)) if block_given?
          run_cli(verbose, full_options)
        end
      end

      setup_subtasks(name, *args, &task_block)
    end

    def run_cli(verbose, options)
      require "advertilecop"
      super(verbose, options)
    end
  end
end
